

- wafer 2 写一个自己的接口
    - http://www.ifanr.com/minapp/915777
    
    wafer 2 基于 Node.js 平台，使用了 Koa 2 框架，所以我们的教程也会基于这个环境完成。

我们在 server/controllers 下新建文件 hello.js，然后在文件中，输入如下代码：
```javascript
module.exports = async ctx => {
  ctx.state.data = "Hello World !"
}
```

代码很简单，就是暴露一个返回结果是「Hello World !」的方法，「Hello World !」会被放在请求结果的 data 里。

然后我们打开 server/routes/index.js，添加一句代码：
```javascript
// 测试接口
router.get('/hello', controllers.hello)
```

没错，代码就只有这么多。

保存之后点击「腾讯云」-「上传测试代码」，如果是第一次上传，记得勾上「部署后自动安装依赖」。

等待上传成功，就可以测试我们的接口了。用浏览器访问 xxx.qcloud.la/weapp/hello，看是否返回以下结果：
```javascript
{
  code: 0,
  data: "Hello World !"
}
```

恭喜！你自己开发的第一个接口已经调通了！接下来，我们再看看，前后端如何协同处理网络请求和参数。


- 深入使用 wafer 2 开发
为了满足小程序前后端协同信息处理的需求，SDK 里也封装了网络请求的方法，就是使用 qcloud.request 进行网络请求。

利用它，我们可以确认用户的登录状态，并将用户的会话信息带给服务器。如果没有这些需求，用回 wx.request 也没事。

至于后端，用平常的方法写 API 接口，就可以在小程序里使用了。

需要额外说一下的，是数据库的使用。wafer 2 使用了 Knex 作为数据库的查询构造器，而且已经帮你配置好了。

对于有 SQL 经验的程序员，利用它可以很快上手数据库开发。

进入 phpMyAdmin，我们可以在在 cAppinfo 这个数据库里，创建需要的表。

我们假设已经有一个名为「Book」的表，那么我们应该如何在 wafer2 里，对数据库进行增查改删呢？

话不多说，上代码：
```javascript

const { mysql } = require('../qcloud')
const uuid = require('node-uuid')

module.exports = async ctx => {
  var id = uuid.v1()
  // 增
  var book = {
    id: id,
    name: "冰与火之歌",
    price: 88
  }
  await mysql("Book").insert(book)
  // 查
  var res = await mysql("Book").where({ id }).first()
  // 改
  await mysql("Book").update({ price: 66 }).where({ id })
  // 删
  await mysql("Book").del().where({ id })

  ctx.state.data = "OK"
}

```
数据库操作默认都是异步执行的，如果业务需要数据库读写使用同步方法执行，你需要在操作语句前加上 await。

更高级的 SQL 用法，可以查看 Knex.js 官网。