## 直播设置

- 开通B站直播，获取rtmp地址和直播码,例如
    - rtmp://xl.live-send.acg.tv/live-xl/
    - ?streamname=xxx&key=xxx
- ffmpeg
    - 参考：[ubuntu下 bilibili直播推流 ffmpeg rtmp推送](http://xiaofd.win/bilibili-rtmp.html)
    - 步骤
        - sudo apt install ffmpeg
        - 
```bash
ffmpeg -re -i attraction.mkv -vf subtitles=attraction.srt \
-c:v libx264 -preset veryfast -maxrate 3000k \
-bufsize 6000k -pix_fmt yuv420p -g 50 -b:a 160k -ac 2 \
-ar 44100 -f flv "rtmp://xl.live-send.acg.tv/live-xl/?streamname=xxx&key=xxx"
```

- 使用 OBS Studio 推流
    - 参考
        - [LINUX 也要玩直播](https://benwong.cn/network/Linux-live.html)
        - [OBS 高CPU占用率/画面卡顿/编码慢解决方案大全](https://zhuanlan.zhihu.com/p/25391323)
        - [OBS Studio （工作室版）和Classic（经典版）的区别](https://zhuanlan.zhihu.com/p/25369287)
        - 视频教程：[如何用OBS进行B站直播教程](https://www.bilibili.com/video/av5189122/)
    - 安装 
        - sudo add-apt-repository ppa:obsproject/obs-studio
        - sudo apt-get update
        - sudo apt-get install obs-studio
    - 使用
        - 在推流之前我们要设置好相关参数。首先进入串流的选项卡，在串流类型里选择自定义流媒体服务器。然后进入 直播中心，点右上角我要直播，编辑好房间信息，点击播放器右上角的滑块开始直播，你就能得到你的rtmp地址和你的直播码，分别就是URL和流密钥，填入串流选项卡的对应位置。
        - 切换到输出选项卡，要调整高级设置的先在输出模式选高级。在下面流的选项卡里，比特率设置的就是码率，如果像我这样只直播写代码的设置 1500 就差不多了，要直播游戏或者视频的可以填 2500；想固定码率的就勾选使用 CBR，想直播流畅的就取消勾选；CRF定义画面质量，可以保持默认；可变帧率那里勾选了就更能节省带宽。
        - 视频选项卡里面，输出分辨率建议设置 1280x720；缩放过滤器那里据说从上到下是画质差到画质好。其他的按自己喜欢去选或者保持默认吧。
        - 配置好以后，点确定保存设置，回到主界面点开始推流就能开始网上直播，点开始录制就能同步录制直播的内容。（P.S. B 站提供的 URL 和直播码是会变动的，如果推流等待时间很长、连不上或是别人看不见直播可以试试重新获取 URL 和直播码。）
- 使用 B 站直播姬 Python 版
    - [Python 抓取 B 站直播弹幕](https://github.com/lyyyuna/bilibili_danmu)

- 其他
    - Mac电脑使用OBS的时候往往会遇到这样一个问题，外界的声音可以录取，但是电脑自身发出的声音，比如音乐，某些网站的声音，是不能直播，这时候我们需要下载一个软件，soundflower，下载之后，进入系统偏好设置->声音-->输出，然后选中Multi-Output Device 
        - http://www.cnblogs.com/Mike-Fighting/p/5324689.html
    
- 直播用途
    - 写代码
    - 玩游戏，网络，单机，手机，游戏机
    - 一起看电影