时间和计划
本节的目的是让您更深入地了解时间如何通过SimPy，以及如何安排和处理事件。

时间是什么？
时间本身并不容易掌握。在维基描述它是这样的：

“时间是存在和事件的无限持续进展，从过去到现在到将来，这种存在和事件显然是不可逆转的。时间是用来排序事件的各种测量的组成部分，比较事件的持续时间或它们之间的时间间隔，并量化物质现实或意识体验中数量的变化率。时间通常被称为第四维度，以及三个空间维度。»
它有什么问题？
通常，事件（在现实世界中）似乎在“同一时间”发生，事实上它们发生的时间稍有不同。这是一个明显的例子：Alice和Bob在同一天生日。如果你的时间尺度是几天，两个生日事件同时发生。如果你增加你钟表的分辨率，例如分钟，你可能会意识到，爱丽丝实际上是早上0:42出生，鲍勃是11:14，这两次事件之间的时间差别很大。

在计算机上进行模拟也会遇到类似的问题。整数（也是浮点数）是离散数字，它们之间有很多空白。因此，如果映射到整数比例（例如，在t = 0），在现实世界中彼此之后会发生的事件（例如，在t 1 = 0.1和 t 2 = 0.2）可能发生在“相同”时间。

另一方面，SimPy（就像大多数仿真框架一样）是一个单线程，确定性的库。它依次处理事件 - 一个接一个。如果两个事件同时被调度，则首先调度的事件也将是首先处理的（FIFO）。

这对你的理解非常重要。模拟/模拟世界中的进程可能“并行”运行，但是当模拟在CPU上运行时，所有事件将按顺序进行并确定性地进行处理。如果你多次运行你的模拟（如果你不使用random;-)），你总会得到相同的结果。

所以记住这一点：

在现实世界中，通常不会同时存在。
时间离散化可以使事件同时出现。
即使他们有相同的时间，SimPy 也会一个接一个地处理事件。
SimPy事件和时间
在我们继续之前，让我们回顾一个事件可以进入的状态（详情请看 事件）：

未触发：不知道事件队列
触发：计划在时间t并插入到事件队列中
处理：从事件队列中移除
SimPy中的事件队列实现为堆队列：“堆是二叉树针对每个父节点具有小于或等于它的任何孩子的值。”所以，如果我们插入事件的元组（T，事件）（与牛逼感在预定时间内），队列中的第一个元素将按照定义始终是最小的t和下一个要处理的元素。

但是，如果两个事件同时进行计划，则存储（t，事件）元组将不起作用，因为事件不具有可比性。为了解决这个问题，我们还存储一个严格增加的事件ID：（t，eid，event）。这样，如果两个事件同时进行计划，则首先计划的计划将始终首先处理。