
# 微信小程序-本地调试-Django

- 使用ngrok tunnel(隧道)工具,内网穿透
    - https://ngrok.com/
    - 可以用来建立public到localhost的tunnel，让居于内网主机上的服务可以暴露给public，俗称内网穿透。 
    - 支持对隧道中数据的introspection（内省），支持可视化的观察隧道内数据，并replay（重放）相关请求（诸如http请 求）。
    
- 参考文档：
    - [django后台开发微信小程序](https://blog.csdn.net/sinat_30062549/article/details/76503980)

        - >前端和后端交互问题：
        - >在微信小程序本地开发阶段，可以通过开发环境不校验请求域名、TLS版本，以及HTTPS证书按钮设置实现通信。
        - >但是如果要真正的发布小程序，就会发现 微信小程序和后端进行交互安全要求是很高的，https传输，就是说，你要1）有域名（已备案），2）ssl证书，3）然后域名解析，4）域名绑定后端服务器，
        - >如果要配置这些东西能消除人学习小程序的完全的兴趣（所以我选择了其他的方法，花了一些money，如有需要，链接如下：）http://blog.csdn.net/sinat_30062549/article/details/76521773   
        - >当完成该教程同时通过域名能够访问你的web服务器时，你的配置就成功了。
        - >然后你需要登录你的微信小程序账号，找到：设置->开发设置->服务器域名->然后把你得到的域名加上去。（在开发者工具上要进行刷新才能得到修改后的结果。）

- 步骤
    - 注册https://ngrok.com/
    - 拿到 authtoken https://dashboard.ngrok.com/auth
    - 下载 客户端 https://ngrok.com/download
    - 运行
        - 验证 ./ngrok authtoken  你的authtoken 
        - 运行 ./ngrok
            - 显示动态域名 https://sfjkdr.ngrok.io -> localhost:8000
            - 重启，域名会变化
            - ngrok http 8000
    - 小程序
        - 选中【开发环境不校验请求域名、TLS版本，以及HTTPS证书按钮设置实现通信。】
        - 代码中 wx.request url 为 https://sfjkdr.ngrok.io/some/json
        
    - Django 
        - settings.py 添加ALLOWED_HOSTS
            - ALLOWED_HOSTS = ['127.0.0.1','sfjkdr.ngrok.io']
        - 运行Django
            - python3.6 manage.py runserver 8000
    - 预览代码，手机微信扫码二维码，体验小程序
    - 可能什么都没有，打开【调试】
    - 成功
            