## Google AIY kit 编程指南

- 参考
    - [Raspberry Pi Google AIY GPIO Voice Control](https://www.youtube.com/watch?v=Y8joFK2O8Es)
    
- cloudspeech ：LED指令
```python
recognizer = aiy.cloudspeech.get_recognizer()
recognizer.expect_phrase('turn off the light')
recognizer.expect_phrase('turn on the light')
recognizer.expect_phrase('blink')
    
text = recognizer.recognize()
if text is None:
    print('Sorry, I did not hear you.')
else:
    print('You said "', text, '"')
    if 'turn on the light' in text:
        aiy.audio.say ('I will turn on the light')
        led.set_state(aiy.voicehat.LED.ON)
    elif 'turn off the light' in text:
        aiy.audio.say ('OK, I will turn off the light')
        led.set_state(aiy.voicehat.LED.OFF)
    elif 'blink' in text:
        aiy.audio.say ('I will make the light do a cool blinky thing')
        led.set_state(aiy.voicehat.LED.BLINK)
    elif 'goodbye' in text:
        aiy.audio.say ('All finished. I enjoyed running that code')
        break    
```    

- Linux 本地命令，使用subprocess
    - 参考 https://github.com/google/aiyprojects-raspbian/blob/voicekit/src/assistant_library_with_local_commands_demo.py